#!/bin/sh

TOTAL_SIG_COUNT=150000
CONFIG_FILE="/etc/packetprotector.conf"
PROXY=`grep "dansguardian=" $CONFIG_FILE | cut -d "=" -f 2`
if [ "X$PROXY" = "X1" ] ; then

	cd /packetprotector/tmp
	mkdir clamav
	cd clamav

	#FETCH DAILY UPDATES
	wget http://db.local.clamav.net/daily.cvd
	if [ $? -ne 0 ] ; then
		echo "Failed to fetch daily.cvd!"
		rm -rf /packetprotector/tmp/clamav
		exit
	fi
	/packetprotector/usr/sbin/sigtool --unpack=./daily.cvd

	DAILY_SIG_COUNT=`cat daily.mdb | wc -l`
	MAIN_SIG_COUNT=`expr $TOTAL_SIG_COUNT - $DAILY_SIG_COUNT`

	#UPDATE SIGNATURES
	if [ $MAIN_SIG_COUNT -gt 0 ] ; then
		cp daily.mdb /packetprotector/usr/share/clamav
		RANDOM_START=$((($RANDOM*$RANDOM)%$MAIN_SIG_COUNT))
		tail -n+$RANDOM_START /packetprotector/usr/share/clamav/main.mdb.FULL | head -$MAIN_SIG_COUNT > main.mdb
		CURRENT_SIG_COUNT=`cat main.mdb | wc -l`
		REMAINING_SIG_COUNT=`expr $MAIN_SIG_COUNT - $CURRENT_SIG_COUNT`
		if [ $REMAINING_SIG_COUNT -gt 0 ] ; then
			head -$REMAINING_SIG_COUNT /packetprotector/usr/share/clamav/main.mdb.FULL >> main.mdb 
		fi
		cp main.mdb /packetprotector/usr/share/clamav
	else
		tail -$TOTAL_SIG_COUNT daily.mdb > /packetprotector/usr/share/clamav/daily.mdb
	fi

	#FETCH HOTLISTS
	cd /packetprotector/tmp/clamav
	wget http://packetprotector.org/download/hotlist.mdb
	wget http://packetprotector.org/download/hotlist.ndb
	if [ $? -ne 0 ] ; then
		echo "Failed to fetch hotlist!"
		rm -rf /packetprotector/tmp/clamav
		exit
	fi
	cp hotlist.mdb /packetprotector/usr/share/clamav/
	cp hotlist.ndb /packetprotector/usr/share/clamav/

	#CLEANUP TMP DIR
	rm -rf /packetprotector/tmp/clamav

	#RELOAD CLAMD
	echo RELOAD | /packetprotector/usr/sbin/socat - /tmp/clamd
echo 'Done.'
date "+%a %b %d %H:%M:%S %Y" > /packetprotector/usr/share/clamav/last_updated
fi
